--==--==--==--==--==--==--==--==--
-- WarTanks Script Version 1.1  --
--==--==--==--==--==--==--==--==--
--         Edit is good         --
--       Reupload is good       --
--     Forget my name is bad    --
--==--==--==--==--==--==--==--==--
--   Script by [TW2D]Razgriz    --
--  Graphics by [TW2D]Razgriz   --
--==--==--==--==--==--==--==--==--

menuname="Tank weapon select"		-- Tank Menu name.
home="gfx/wartank/"					-- Images home menu.
tank_speed=10						-- Default tank speed. Changable.
tank_body="body.png"				-- Default tank body. Changable.
bot_uses=3							-- Tank that bot uses.
admin={7863}						-- Change it to your USGN, comma to separate.

function initArray(m,n)
	local array = {}
	for i = 1, m do
		array[i]=n
	end
	return array
end

lx=initArray(32,0)
ly=initArray(32,0)
c=string.char(169)
body=initArray(32,0)
weapon=initArray(32,0)
pause=initArray(32,false)
parse("mp_deathdrop 4")
tablecount=0
smoking=true

function customdamage(m,n)
	parse('mp_wpndmg "'..m..'" '..n)
end
dofile("sys/lua/wartank/tank.lua")

function createmenu(id)
	local tmp=""
	for d1, d2 in ipairs(tank_type) do
		tmp = tmp..d2.name.."|"..d2.desc..","
	end
	menu(id,menuname.."@b,"..tmp)
end

function createimage(id,sel)
	if tank_type[sel].body then
		body[id]=image(home..tank_type[sel].body,0,0,id+200,0)
	else
		body[id]=image(home.."body.png",0,0,id+200,0)
	end
	weapon[id]=image(home..tank_type[sel].image,1,0,id+200,0)
	if tank_type[sel].speed then
		parse("speedmod "..id.." "..tank_type[sel].speed)
	else
		parse("speedmod "..id.." "..tank_speed)
	end
end

addhook("join","tank_admin")
function tank_admin(id)
	for _, usgn in ipairs(admin) do
		if player(id,'usgn') == usgn then
			return true
		end
	end
	return false
end

addhook("serveraction","tank_fkeys")
function tank_fkeys(id,fkey)
	if fkey==1 then parse("killplayer "..id) end
end


addhook("menu","tank_menu")
function tank_menu(id,tit,sel)
	if tit==menuname then
		if sel>0 then
			parse("equip "..id.." "..tank_type[sel].weapon)
			parse("setweapon "..id.." "..tank_type[sel].weapon)
			parse("setarmor "..id.." "..tank_type[sel].armor)
			parse("setmaxhealth "..id.." "..tank_type[sel].health)
			createimage(id,sel)
		elseif sel==0 then
			createmenu(id)
		end
	end
end

addhook("spawn","tank_spawn")
function tank_spawn(id)
	local isbot=player(id,"bot")
	parse("speedmod "..id.." -100")
	if player(id,"team")==1 then parse("strip "..id.." 2") end
	if player(id,"team")==2 then parse("strip "..id.." 1") end
	if isbot==false then createmenu(id) pause[id]=true end
	if isbot==true then
		local r=math.random(1,9)
		if tank_type[bot_uses] then
		createimage(id,bot_uses)
		parse("equip "..id.." "..tank_type[bot_uses].weapon)
		parse("setweapon "..id.." "..tank_type[bot_uses].weapon)
		parse("setarmor "..id.." "..tank_type[bot_uses].armor)
		parse("setmaxhealth "..id.." "..tank_type[bot_uses].health)
		end
	end
end

addhook("move","tank_rotate")
function tank_rotate(id,x,y)
	if lx[id]>x and ly[id]>y then						-- left up
		if body[id] then
			imagepos(body[id],0,0,-45)
		end
	elseif lx[id]>x and ly[id]<y then					-- left down
		if body[id] then
			imagepos(body[id],0,0,225)
		end
	elseif lx[id]<x and ly[id]>y then					-- right up
		if body[id] then
			imagepos(body[id],0,0,45)
		end
	elseif lx[id]<x and ly[id]<y then					-- right down
		if body[id] then
			imagepos(body[id],0,0,135)
		end
	elseif lx[id]>x  then								-- left
		if body[id] then
			imagepos(body[id],0,0,270)
		end
	elseif lx[id]<x then								-- right
		if body[id] then
			imagepos(body[id],0,0,90)
		end
	elseif ly[id]>y  then								-- up
		if body[id] then
			imagepos(body[id],0,0,0)
		end
	elseif ly[id]<y  then								-- down
		if body[id] then
			imagepos(body[id],0,0,180)
		end
	end
	lx[id]=x
	ly[id]=y
end

addhook("die","tank_die_effect")
function tank_die_effect(id)
	freeimage(body[id])
	freeimage(weapon[id])
	parse("effect \"fire\" "..player(id,"x").." "..player(id,"y").." 5 96 255 0 0")
end

addhook("buy","tank_noeffect")
addhook("drop","tank_noeffect")
addhook("buildattempt","tank_noeffect")
function tank_noeffect(id)
	return 1
end

addhook("walkover","tank_walkover")
function tank_walkover(id,iid,type,ain,a,mode)
	msg2(id,type)
	if type==64 or type==65 then
		return 0
	else
		return 1
	end
end

function tank_hitignore(id)
	if paused[id] then return 1 end
end

------Fast-Reload-------
------By leon7070-------
------06.10.2010--------
---www.newearth.de.tt---

addhook("reload","tank_noreload")
function tank_noreload(id,mode)
	wp = player(id,"weapontype")
	if mode==1 then
		parse("equip "..id.." "..wp)
		parse("setweapon "..id.." "..wp)
	end
end

addhook("say","tank_say")
function tank_say(id,txt)
	if string.sub(txt,1,1)=="!" then
		if tank_admin(id) then
			local com=string.sub(txt,2)
			local name=player(id,"name")
			if com=="smoke" then
				if smoking then
					smoking=false
					msg2(id,c.."128255000"..name.." has turned off smoke!@C")
				else
					smoking=true
					msg2(id,c.."128255000"..name.." has turned on smoke!@C")
				end
			end
		else
			msg2(id,c.."255000000You have no right to use commands!")
		end
		return 1
	end
end

addhook("second","tank_smoke")
function tank_smoke()
	if smoking then
		for i in ipairs(player(0,"table")) do
			if player(i,"exists") then
				if player(i,"health")>=30 then
					parse("effect \"smoke\" "..player(i,"x").." "..player(i,"y").." 0 32")
				end
			end
		end
	end
end

addhook("ms100","tank_emergencysmoke")
function tank_emergencysmoke()
	if smoking then
		for i in ipairs(player(0,"table")) do
			if player(i,"exists") then
				if player(i,"health")<30 and player(i,"health")>0 then
					parse("effect \"smoke\" "..player(i,"x").." "..player(i,"y").." 5 32")
				end
			end
		end
	end
end